/*
 * plclgthread.cpp
 *
 *	10.04.06 - SF: first release  
 *
 *
 */

#include "plclgthread.h"


/* 
 *	plclgthread::run()
 *	Run  
 */		
void *plclgthread::run_undetached(void *) 
{
	struct timeval _pre2, _post2;
	int pausesec2,pausenano2;
	unsigned char buf_local_tstamp[TSTAMP_SIZE];
	char buf_tmp[10];
	
	
	//semaphore management
	
	retval = 0;
	id = semget(1000, 1, 0666);
	if(id < 0){
		DEBUG_STREAM << "plclgthread::lgThread cannot find semaphore" << endl;
	}
	else{
		DEBUG_STREAM << "plclgthread::lgThread found semaphore" << endl;
	}
   
	while (!t_PLCsocket->abortflag) { 
		
	//log to db elements of the message list
		int k=0;

		PLCsocket_ns::intlck_libera_t m;
		
		
		operations[0].sem_num = 0;
		operations[0].sem_op = 0;
		operations[0].sem_flg = 0;
		lock_ops[0].sem_num = 0;
		lock_ops[0].sem_op = 1;
		lock_ops[0].sem_flg = 0;
		unlock_ops[0].sem_num = 0;
		unlock_ops[0].sem_op = -1;
		unlock_ops[0].sem_flg = 0;
		
		while(!t_PLCsocket->mesg_list.empty()){
			retval = semop(id, operations, 1);
			m = t_PLCsocket->mesg_list.front();
			t_PLCsocket->log_msg(m);
			t_PLCsocket->mesg_list.pop_front();
		//saving old message
		  	bcopy(&t_PLCsocket->message, &t_PLCsocket->old_message, (sizeof(PLCsocket_ns::intlck_libera)));
			t_PLCsocket->message = m;
			char locbuf[SRV_BUF_LEN];	
	  		bcopy(&t_PLCsocket->message, &locbuf, (sizeof(PLCsocket_ns::intlck_libera)));
		//logging on tango debug stream
			char tmp_buf[SRV_BUF_LEN];					
			string x;
			for(int j=0;j<(int)(sizeof(PLCsocket_ns::intlck_libera));j++){
   				memset (tmp_buf, 0, sizeof(tmp_buf) );
				sprintf(tmp_buf, "%02X-", locbuf[j]);//change here the format of saved data
				x.append(tmp_buf);
				}
			printf("%s\n",x.c_str());
//////////////////////////////////////////////////////////////////////////disabled
/*					if(t_PLCsocket->logging_msg == 1){	
						char tmp_buf[SRV_BUF_LEN];					
						string x;
						for(int j=0;j<(int)(sizeof(PLCsocket_ns::intlck_libera)/4);j++){
   							memset (tmp_buf, 0, sizeof(tmp_buf) );
							sprintf(tmp_buf, "%02X-", locbuf[j]);//change here the format of saved data
							x.append(tmp_buf);
						}
						DEBUG_STREAM << x << endl;
						x.clear();
						for(int j=(int)(sizeof(PLCsocket_ns::intlck_libera)/4);j<(int)(sizeof(PLCsocket_ns::intlck_libera)/2);j++){
   							memset (tmp_buf, 0, sizeof(tmp_buf) );
							sprintf(tmp_buf, "%02X-", locbuf[j]);//change here the format of saved data
							x.append(tmp_buf);
						}
						DEBUG_STREAM << x << endl;
						x.clear();
						for(int j=(int)(sizeof(PLCsocket_ns::intlck_libera)/2);j<(int)(sizeof(PLCsocket_ns::intlck_libera)*3/4);j++){
   							memset (tmp_buf, 0, sizeof(tmp_buf) );
							sprintf(tmp_buf, "%02X-", locbuf[j]);//change here the format of saved data
							x.append(tmp_buf);
						}
						DEBUG_STREAM << x << endl;
						x.clear();
						for(int j=(int)(sizeof(PLCsocket_ns::intlck_libera)*3/4);j<sizeof(PLCsocket_ns::intlck_libera);j++){
   							memset (tmp_buf, 0, sizeof(tmp_buf) );
							sprintf(tmp_buf, "%02X-", locbuf[j]);//change here the format of saved data
							x.append(tmp_buf);
						}
						DEBUG_STREAM << x << endl;
					}*/
///////////////////////////////////////////////////////////////////////////////////					
	//detects alarmed inputs
			if((m.campo_ingressi_1&m.campo_ingressi_2&
				m.campo_ingressi_3&m.campo_ingressi_4&
				m.campo_ingressi_5) == 0xffff){//no alarm found
				;
			}
			else{
	//prepare ack mask and send auto acknowledge
					
				t_PLCsocket->i_answer.ack_1 = 0xffff&(~(m.memo_allarmi_1));
				t_PLCsocket->i_answer.ack_2 = 0xffff&(~(m.memo_allarmi_2));
				t_PLCsocket->i_answer.ack_3 = 0xffff&(~(m.memo_allarmi_3));
				t_PLCsocket->i_answer.ack_4 = 0xffff&(~(m.memo_allarmi_4));
				t_PLCsocket->i_answer.ack_5 = 0xffff&(~(m.memo_allarmi_5));
						
				if((t_PLCsocket->ack_policy)==AUTO_ACK)
					t_PLCsocket->send_auto_ack();
			}
					
	//pushing user events to subscribed clients
	//the XOR between old and new monitored signals traces changes

			if ((m.mesg_type & CHANGE_MESG) || \
				(m.mesg_type & BDCA_MESG) || \
				(m.mesg_type & PERIODIC_MESG)) { //if it is NOT a periodic message
				t_PLCsocket->push_it();
				t_PLCsocket->seq[1] = m.seq_async;	
			}//changes not monitored from plc, like beam abi
			else {
				int condition[9];
				condition[0] = m.campo_ingressi_1^t_PLCsocket->old_message.campo_ingressi_1;
				condition[1] = m.campo_ingressi_2^t_PLCsocket->old_message.campo_ingressi_2;
				condition[2] = m.campo_ingressi_3^t_PLCsocket->old_message.campo_ingressi_3;
				condition[3] = m.campo_ingressi_4^t_PLCsocket->old_message.campo_ingressi_4;
				condition[4] = m.campo_ingressi_5^t_PLCsocket->old_message.campo_ingressi_5;
				condition[5]=((m.campo_uscite_2&PLCsocket_ns::maskbits[0])^(t_PLCsocket->old_message.campo_uscite_2&PLCsocket_ns::maskbits[0]));

				if((condition[0]|condition[1]|condition[2]|condition[3]|condition[4]|condition[5])!=0x0000){
					t_PLCsocket->push_it();
				}
			}
					
			k++;
		}
		DEBUG_STREAM << "plclgthread::popped "<< k <<" packets" << endl;
		usleep(1000000);//sleep for 1s
		
	}
}




