/*
 * plclgthread.h
 *
 *	17.01.07 - SF: heartbeat
 */ 

#ifndef plclgthread_H
#define plclgthread_H

#include <omnithread.h>
#include <tango.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <signal.h>
#include <netdb.h>    
#include "PLCsocket.h"

#define SRV_BUF_LEN 2048
class plclgthread : public omni_thread, public Tango::LogAdapter
{	
	private:
		PLCsocket_ns::PLCsocket::PLCsocket *t_PLCsocket;		
				
	public:
		
		plclgthread(PLCsocket_ns::PLCsocket::PLCsocket *s):Tango::LogAdapter(s){ t_PLCsocket = s;};
		
		~plclgthread() {};
		
		void *StartUndetached(){
			start_undetached();
		}
		void *run_undetached(void *);	
					
	protected:
	
   		struct sembuf operations[1];
   		struct sembuf lock_ops[1];
   		struct sembuf unlock_ops[1];
   		int retval;
   		int id;
		
		struct timeval _pre2, _post2;
				
};	/* end class plclgthread() */



#endif

/* EOF */
